<?php
/**
* This class is loaded on the front-end since its main job is
* to display the WhatsApp box.
*/
class GWAA_Backend {
	
	public function __construct () {
		add_action('admin_menu', array($this,'GWAA_cf7_address_autocomplete_menu_item'));
		add_action('admin_init', array($this,'GWAA_cf7_address_autocomplete_display_gpa_fields'));
		add_action( 'wp_enqueue_scripts', array($this,'GWAA_cf7_gpa_load_user_api' ));
	}
	public function GWAA_cf7_address_autocomplete_menu_item()
	{
		add_submenu_page(
											'wpcf7',
											__('Google Place API','google-place-api'),
											__('Google Place API','google-place-api'), 
											'manage_options',
											'google-place-api',
											array($this, 'GWAA_cf7_google_place_admin' ),
										);
	}
	public function GWAA_cf7_google_place_admin()
	{
		$gwaa_country_code = get_option('gwaa_country_code','');
		$gwaa_address_option = get_option('gwaa_address_option',array());
		if(empty($gwaa_address_option)){
        	$gwaa_address_option = array();
        }
        $gwaa_place_types = get_option('gwaa_place_types','');
        $gwaa_enable_map = get_option('gwaa_enable_map','');
        
?>
		<div class="wrap">
			<h1>Google Places API Info.</h1>
			<form method="post" action="options.php">
				<?php settings_fields( 'gwaa_section' ); ?>
				<table class="form-table" role="presentation">
				   <tbody>
				      <tr>
				         <th scope="row">Google Places API Key</th>
				         <td>
				            <input type="text" class="regular-text" required="" name="gwaa_cf7_geo_api_key" id="api_key" value="<?php echo get_option('gwaa_cf7_geo_api_key');?>">
				            <p class="description">Google requires an API key to retrieve Auto Complete Address for job listings. Acquire an API key from the <a target="_blank" href="https://developers.google.com/maps/documentation/javascript/places-autocomplete">Google Maps API developer site</a>.</p>
				         </td>
				      </tr>
				      <tr valign="top">
			            <th scope="row">
			               <label>Specific Country Address Show</label>
			            </th>
			            <td>
			               <input class="regular-text" type="text" placeholder="US,AU" name="gwaa_country_code" value="<?php echo $gwaa_country_code; ?>"  />
			               <p class="description"><strong>Default is blank</strong> it will be show all Country address if you want to particular country address than add two digit code <strong>Example: France for add fr</strong> <a href="https://codesmade.com/demo/country-code-list/">Get Country Code list</a></p>
			            </td>
			         </tr>
			         <tr valign="top">
			            <th scope="row">
			               <label>Enable Map</label>
			            </th>
			            <td>
			            	 <input  type="checkbox"  name="gwaa_enable_map" value="true" <?php echo ($gwaa_enable_map=="true")?'checked':''?> />Show Map on selected address
			            </td>
			         </tr>
			         <tr valign="top">
			            <th scope="row">
			               <label>Enable Address Field Option</label>
			            </th>
			            <td>
			            	 <input  type="checkbox"  name="gwaa_address_option[]" value="street_number" <?php echo (in_array("street_number", $gwaa_address_option))?'checked':''?> />Street Number<br/>
			            	 <input  type="checkbox"  name="gwaa_address_option[]" value="postcode" <?php echo (in_array("postcode", $gwaa_address_option))?'checked':''?>  />Postcode<br/>
			            	 <input  type="checkbox"  name="gwaa_address_option[]" value="locality" <?php echo (in_array("locality", $gwaa_address_option))?'checked':''?>  />Locality<br/>
			            	 <input  type="checkbox"  name="gwaa_address_option[]" value="administrative_area_level_1" <?php echo (in_array("administrative_area_level_1", $gwaa_address_option))?'checked':''?> />State<br/>
			            	 <input  type="checkbox"  name="gwaa_address_option[]" value="country" <?php echo (in_array("country", $gwaa_address_option))?'checked':''?> />Country<br/>
			            </td>
			         </tr>
			          <tr valign="top">
			            <th scope="row">
			               <label>Place Types</label>
			            </th>
			            <td>
			               <input class="regular-text" type="text" placeholder="airport,art_gallery" name="gwaa_place_types" value="<?php echo $gwaa_place_types; ?>"  />
			               <p class="description"><strong>Default is blank</strong> You can setup place type there. example if you want art gallery than you need to add there <strong>art_gallery</strong>.<a href="https://developers.google.com/maps/documentation/places/web-service/supported_type">Get Place Type</a></p>
			            </td>
			         </tr>
				   </tbody>
				</table>
				<?php
					     
					submit_button(); 
				?>
			
			</form>
		</div>
<?php
	}
	
	public function GWAA_cf7_address_autocomplete_display_gpa_fields()
	{
		
			
			register_setting('gwaa_section', 'gwaa_cf7_geo_api_key');
			register_setting('gwaa_section', 'gwaa_country_code');
			register_setting('gwaa_section', 'gwaa_address_option');
			register_setting('gwaa_section', 'gwaa_place_types');
			register_setting('gwaa_section', 'gwaa_enable_map');
	  
	}

	public function GWAA_cf7_gpa_load_user_api()
	{
		$api_script ='';
	  $gpa_page = get_option( 'gwaa_cf7_geo_gpa_page' );
	  $api_key = get_option( 'gwaa_cf7_geo_api_key' );
	  if(is_ssl())
	  {
			$securee = 'https';
	  }
	  else
	  {
			$securee = 'http';
	  }
	  $api_script .= $securee.'://maps.googleapis.com/maps/api/js?key=' . $api_key . '&libraries=places';
	 //$api_script ='https://maps.googleapis.com/maps/api/js?v=3.exp&sensor=false&libraries=places';
		  wp_enqueue_script( 'gpa-google-places-api', $api_script, array(), 'null', true );
		
	}
	
	
}
?>